=== gba-driver/PKGBUILD ===
#!/bin/bash

name=gba-driver
ver=1.0.0
arch=all

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'


if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi


extract() {
    cd /tmp || exit
    mv gba*.tar target.tar
    mkdir /tmp/target/
    tar xf /tmp/target.tar --directory /tmp/target/
    cd /tmp/target || exit
    cp /tmp/target/gba.png /etc/spkg/gba.png
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing drivers/gba-driver ... "
    echo -e "${Bold} hello your computa has virus"
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing drivers/gba-driver ... "
    echo -e "${Bold} hello your computa has virus"
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Sure? ... "
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi
